#ifndef _EMU_MATH_H_
#define _EMU_MATH_H_

void     long_mul(u128_t *product, u64_t op1, u64_t op2);
void     long_neg(s128_t *n);
void     long_imul(s128_t *product, s64_t op1, s64_t op2);
void     long_shl(u128_t *a);
void     long_shr(u128_t *a);
unsigned long_sub(u128_t *a, u128_t *b);
int      long_le(u128_t *a, u128_t *b);
void     long_div(u128_t *quotient, u64_t *remainder, u128_t *dividend, u64_t divisor);
void     long_idiv(s128_t *quotient, s64_t *remainder, s128_t *dividend, s64_t divisor);

#endif